]> git.pld-linux.org Git - packages/rpm.git/blame - rpm.macros
- add %pld_release macro
[packages/rpm.git] / rpm.macros
CommitLineData
b52fc1f1 1# $Revision$, $Date$
cc2b296f 2# PLD Linux rpm macros
a8bf9720 3
90c0eaed 4%epoch 0
31b569b6 5%x8664 x86_64 amd64 ia32e
cd33aab7 6
a544555d 7# kernel compiler
6f86c45e 8%kgcc %{__cc}
cabacfeb 9%kgcc_package gcc
a544555d 10
4343a1f7
ER
11%__rm /bin/rm --interactive=never
12
5f9f9bd7 13# Build system path macros.
14#
8af1c6f5
JB
15%__autoconf autoconf %{?debug:-Wall}
16%__automake automake -a -c -f --foreign
429d047e 17%__autopoint autopoint --force
18
aad1c8e4 19%__gettextize { \
4cd84746 20 if grep -qs 'AM_GNU_GETTEXT.*external' configure.{ac,in} ; then \
31b569b6 21 gettextize --copy --force --no-changelog; \
93bce43f 22 else \
31b569b6 23 gettextize --copy --force --no-changelog --intl; \
4cd84746
JB
24 fi; \
25 if [ ! -f po/Makevars ]; then \
31b569b6 26 cp -f po/Makevars{.template,}; \
4cd84746 27 fi; \
4cd84746 28}
429d047e 29
30%__glib_gettextize glib-gettextize --copy --force
31%__gnome_doc_common gnome-doc-common --copy
db1adf13 32%__gnome_doc_prepare gnome-doc-prepare --copy --force
429d047e 33%__gtkdocize gtkdocize --copy
34%__intltoolize intltoolize --copy --force
35%__libtoolize libtoolize --copy --force
5f9f9bd7 36
702e8027 37# Path to top of build area.
135188cb 38%_topdir %{expand:%%global _topdir %(test -d ../SPECS -a -d ../SOURCES && (cd ..; pwd) || echo $HOME/rpm)}%_topdir
702e8027 39
38e780ca
ER
40# The number of cvs changelog entries kept when building package.
41%_buildchangelogtruncate 20
42
bd1cd543 43%dependencytracking %{nil}
31b569b6 44
073ae3ba
ER
45# Relations between package names that cause dependency loops
46# with legacy packages that cannot be fixed. Relations are
47# specified as
48# p>q
49# where package p has a Requires: on something that package q Provides:
50#
51# XXX Note: that there cannot be any whitespace within the string "p>q",
52# and that both p and q are package names (i.e. no version/release).
53%_dependency_whiteout %{nil}
54
9ba56d1b
AM
55%_smp_mflags %([ -z "$RPM_BUILD_NCPUS" ] \\\
56 && RPM_BUILD_NCPUS="`/usr/bin/getconf _NPROCESSORS_ONLN`"; \\\
57 [ "$RPM_BUILD_NCPUS" -gt 1 ] && echo "-j$RPM_BUILD_NCPUS")
cece03f9 58
59#-----------------------------------------------------------------
60#
61# (re)definition of %{rpm*flags} with %filterout_* support
7c9f98ce
ER
62# BuildRequires: awk
63# BuildRequires: rpmbuild(macros) >= 1.315
cece03f9 64#
65# Flags specified in %filterout_* are removed from %rpm*flags, exactly:
a0bf497e 66# %rpmcflags = %optflags - %filterout - %filterout_c - %filterout_ld
67# %rpmcxxflags = %optflags - %filterout - %filterout_cxx - %filterout_ld
68# %rpmldflags = %optldflags - %filterout_ld
cece03f9 69#
70# Regular expressions are supported, but to avoid some character be treated
71# as regular expression it must be escaped twice.
72
73%filter_out \
bf66145e 74 for (i = 1; i in I; i++) { A=0; \
cece03f9 75 for (f in F) { \
76 if (I[i] ~ "^" F[f] "$") A=1; \
77 }; \
78 if (!A) printf(I[i] FS); \
79 }
80
81%rpmcflags %(awk 'BEGIN {
82 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
a0bf497e 83 split("%{?filterout} %{?filterout_c} %{?filterout_ld}",F);
cece03f9 84 %{filter_out}
85}')
86
87%rpmcxxflags %(awk 'BEGIN {
a0bf497e 88 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
89 split("%{?filterout} %{?filterout_cxx} %{?filterout_ld}",F);
cece03f9 90 %{filter_out}
91}')
92
93%rpmldflags %(awk 'BEGIN {
b699ccff 94 split("%{?optldflags}",I);
cece03f9 95 split("%{?filterout_ld}",F)
96 %{filter_out}
97}')
98
111942c6 99# rpmldflags with stripped -Wl, -- in the form flags have to be passed to 'ld'
100# but, don't use it, better use gcc as linker
101%ld_rpmldflags %(awk 'BEGIN {
102 split("%{rpmldflags}",F);
103 for (f in F) {
104 s = F[f];
105 if (s ~ /^-Wl,/) {
106 s = substr(s,5);
107 gsub(/,/," ",s);
108 };
109 printf(s FS);
110 };
111}')
112
cd33aab7 113#-----------------------------------------------------------------
9f0287b5 114%configure2_13 { \
cd33aab7
AM
115 if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
116 LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
117 CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
af18d245 118 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
cd33aab7 119 FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
d4392e78 120 FCFLAGS="${FCFLAGS:-%rpmcflags}" ; export FCFLAGS ; \
c55f2219 121 CPPFLAGS="${CPPFLAGS:-}" ; export CPPFLAGS ; \
4eac2e49
AM
122 %{?__cc:CC="%{__cc}" ; export CC ; } \
123 %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
5b0f0ac9 124 %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
fa74a11c 125 --host=%{_target_platform} \
cd33aab7
AM
126 --prefix=%{_prefix} \
127 --exec-prefix=%{_exec_prefix} \
128 --bindir=%{_bindir} \
129 --sbindir=%{_sbindir} \
130 --sysconfdir=%{_sysconfdir} \
131 --datadir=%{_datadir} \
132 --includedir=%{_includedir} \
133 --libdir=%{_libdir} \
134 --libexecdir=%{_libexecdir} \
135 --localstatedir=%{_localstatedir} \
136 --sharedstatedir=%{_sharedstatedir} \
137 --mandir=%{_mandir} \
138 --infodir=%{_infodir} \
c3420100 139 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
8b4be1e1 140 %{dependencytracking} \
cd33aab7
AM
141}
142
53c34296
ER
143# override __cmake to add -j4 in your ~/.rpmmacros for parallel make
144%__cmake /usr/bin/cmake
29771119
ER
145%cmake { \
146CC="%{__cc}" \
147CXX="%{__cxx}" \
148CFLAGS="%{rpmcflags}" \
149CXXFLAGS="%{rpmcxxflags}" \
53c34296
ER
150%{__cmake} \
151}
152
153# override __scons to add -j4 in your ~/.rpmmacros for parallel make
154%__scons /usr/bin/scons
155%scons { \
156%{__scons} \
13eb0f84
ER
157 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
158 CFLAGS="${CFLAGS:-%rpmcflags}" \
159 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
160 FFLAGS="${FFLAGS:-%rpmcflags}" \
161 CPPFLAGS="${CPPFLAGS:-}" \
162 %{?__cc:CC="%{__cc}"} \
163 %{?__cxx:CXX="%{__cxx}"} \
164 libsuffix=%{_lib} \
165 prefix=%{_prefix} \
29771119
ER
166}
167
ac093701 168# waf. see waf.spec
53c34296 169# override __waf to add -j4 in your ~/.rpmmacros for parallel make
ac093701
ER
170%__waf /usr/bin/waf
171%waf { \
ac093701
ER
172CC="%{__cc}" \
173CXX="%{__cxx}" \
1624498d 174CPP="%{__cpp}" \
ac093701
ER
175CFLAGS="%{rpmcflags}" \
176CXXFLAGS="%{rpmcxxflags}" \
177%{__waf} \
ac093701
ER
178}
179
85f82bec 180#----------------------------------------------------------------
b7626f51 181#%configure_cache 0
43f81f06 182%configure_cache_file %{buildroot}.configure.cache
7e4e3f2b 183
b8cf6778 184%configure {./configure \
85f82bec
AF
185 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
186 CFLAGS="${CFLAGS:-%rpmcflags}" \
af18d245 187 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
85f82bec 188 FFLAGS="${FFLAGS:-%rpmcflags}" \
d4392e78 189 FCFLAGS="${FCFLAGS:-%rpmcflags}" \
418d9760 190 CPPFLAGS="${CPPFLAGS:-}" \
4eac2e49
AM
191 %{?__cc:CC="%{__cc}"} \
192 %{?__cxx:CXX="%{__cxx}"} \
a9bea0f7 193 --host=%{_target_platform} \
85f82bec
AF
194 --build=%{_target_platform} \
195 --prefix=%{_prefix} \
196 --exec-prefix=%{_exec_prefix} \
197 --bindir=%{_bindir} \
198 --sbindir=%{_sbindir} \
199 --sysconfdir=%{_sysconfdir} \
200 --datadir=%{_datadir} \
201 --includedir=%{_includedir} \
202 --libdir=%{_libdir} \
203 --libexecdir=%{_libexecdir} \
204 --localstatedir=%{_localstatedir} \
205 --sharedstatedir=%{_sharedstatedir} \
206 --mandir=%{_mandir} \
207 --infodir=%{_infodir} \
c3420100 208 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
8b4be1e1 209 %{dependencytracking} \
b7626f51 210 %{?configure_cache:--cache-file=%{configure_cache_file}} \
85f82bec
AF
211}
212
9cd5fb46
ER
213# overload to insert debuginfo package
214%prep \
215%if 0%{?_enable_debug_packages}\
216%{debug_package}\
217%endif\
218%%prep\
219%{nil}
220
cd33aab7 221# Location of autoconf macros
742f3bc4 222%_aclocaldir %{expand:%%global _aclocaldir %(aclocal --print-ac-dir || echo ERROR)}%_aclocaldir
cd33aab7 223
32720a50 224# Location of omf files
742f3bc4 225%_omf_dest_dir %{expand:%%global _omf_dest_dir %(scrollkeeper-config --omfdir || echo ERROR)}%_omf_dest_dir
32720a50 226
c5eece2c 227# Location of pkgconfig files
a46897a7 228%_pkgconfigdir /usr/%{_lib}/pkgconfig
e2023017
JB
229# noarch pkgconfig files
230%_npkgconfigdir /usr/share/pkgconfig
c5eece2c 231
c917274d 232# Location of desktop files
233%_desktopdir /usr/share/applications
510f694c 234%_applnkdir ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
c917274d 235
fb08fb4a 236# Location of pixmaps for applnk/desktop files
3a9bb008 237%_pixmapsdir /usr/share/pixmaps
cd33aab7 238
fb08fb4a 239# Location of themable icons for applnk/desktop files
986c3bcd 240%_iconsdir /usr/share/icons
241
c5eece2c
JB
242# Location of fonts directories
243%_fontsdir /usr/share/fonts
244
5cfcbc9e 245# Location of Gtk and associated libraries documentation
43f81f06 246%_gtkdocdir %{_defaultdocdir}/gtk-doc/html
5cfcbc9e 247
eee08b2d 248# Location of KDE documentation
43f81f06 249%_kdedocdir %{_defaultdocdir}/kde/HTML
eee08b2d 250
a7cad6ae 251# unsermake script
252%__unsermake /usr/share/unsermake/unsermake
253
cd33aab7
AM
254# Current date
255%date %(LC_ALL="C" date +"%a %b %d %Y")
256
cd33aab7
AM
257# Example files, programs, scripts...
258%_examplesdir /usr/src/examples
259
7127e0fc 260# Alternative kernel type/version
c604d0a9 261%_alt_kernel %{nil}%{?alt_kernel:-%{?alt_kernel}}
7127e0fc 262
bd63739a 263# The directory holding Linux kernel sources
c604d0a9 264%_kernelsrcdir /usr/src/linux%{_alt_kernel}
bd63739a 265
cd33aab7 266# If non-empty "debug" macro defined, add "dbg" suffix to release number
5b0f0ac9 267%_rpmfilename %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
cd33aab7 268
5b0f0ac9 269# Requires name = version-release
48c1bf9f 270%requires_releq() %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %{N} = %|E?{%{E}:}|%{V}-%{R}\\n' | grep -v 'is not')
511ee4c6 271
135188cb
ER
272%releq_kernel %{expand:%%global releq_kernel %(R=$(LC_ALL=C rpm -q --qf '%{N} = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel
273%releq_kernel_up %{expand:%%global releq_kernel_up %(R=$(LC_ALL=C rpm -q --qf '%{N}-up = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_up
274%releq_kernel_smp() %{expand:%%global releq_kernel_smp %(R=$(LC_ALL=C rpm -q --qf '%{N}-smp = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_smp
d606f9ca
ER
275%requires_releq_kernel(s:) Requires%{-s:(%{-s*})}: %releq_kernel
276%requires_releq_kernel_up(s:) Requires%{-s:(%{-s*})}: %releq_kernel_up
277%requires_releq_kernel_smp(s:) Requires%{-s:(%{-s*})}: %releq_kernel_smp
511ee4c6 278
48c1bf9f
ER
279# XXX: why epoch 0 is stripped?
280%requires_eq() %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %{N} = %|E?{%{E}:}|%{V}\\n' | sed -e 's/ 0:/ /' | grep -v 'is not')
281%requires_eq_to() %(LC_ALL="C" rpm -q --qf 'Requires: %1 = %|E?{%{E}:}|%{V}' %2 | grep -v "is not")
e478b9e7 282
a1551c98 283%apache_modules_api %{expand:%%global apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)}%apache_modules_api
8dea1306 284
285# kernel version-release handling
a1551c98
ER
286%__kernel_ver %{expand:%%global __kernel_ver %(VER_H=%{_kernelsrcdir}/include/linux/utsrelease.h; [ -f $VER_H ] || VER_H=%{_kernelsrcdir}/include/linux/version.h; [ -f $VER_H ] && (grep UTS_RELEASE $VER_H 2>/dev/null | head -n 1 | cut -d'"' -f2) || (awk '/^VERSION/ { ver = $0; gsub(/VERSION.*=/, NIL, ver); } /^PATCHLEVEL/ { plev = $0; gsub(/PATCHLEVEL.*=/, NIL, plev); } /^SUBLEVEL/ { slev = $0; gsub(/SUBLEVEL.*=/, NIL, slev); } /^EXTRAVERSION/ { ever = $0; gsub(/EXTRAVERSION.*=/, NIL, ever); gsub(/ /, NIL, ever); } END { printf("%d.%d.%d%s", ver, plev, slev, ever); }' %{_kernelsrcdir}/Makefile 2> /dev/null))}%__kernel_ver
287%__kernel_rel %{expand:%%global __kernel_rel %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rel
288%__kernel_rpmvr %{expand:%%global __kernel_rpmvr %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{V}-%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rpmvr
289%_kernel_ver %{expand:%%global _kernel_ver %{__kernel_ver}%{?with_dist_kernel:%(echo %{__kernel_ver} | grep -q -e - || echo -%{__kernel_rel})}}%_kernel_ver
290%_kernel_ver_str %{expand:%%global _kernel_ver_str %(echo %{!?_without_dist_kernel:%{__kernel_rpmvr}}%{?_without_dist_kernel:%{__kernel_ver}} | sed -e 's/-/_/g')}%_kernel_ver_str
fd4d8ee0 291
c2c27a5a 292# sgml macros
31b569b6
ER
293%xmlcat_add() /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
294%xmlcat_del() /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
295%xmlcat_add_rewrite /usr/bin/xmlcatalog --noout --add rewriteSystem
296%xmlcat_create() /usr/bin/xmlcatalog --noout --create %1 ;
297%sgmlcat_add() /usr/bin/install-catalog --add %1 %2 > /dev/null ;
298%sgmlcat_del() /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
c2c27a5a 299%docbook_sgmlcat_fix() { for l in \
300'' \
301' -- default decl --' \
302'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
303' -- hacks for opensp --' \
304'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
305'SYSTEM "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
306'' \
307; do echo $l; done >> %1 \
308}
309
31bd34a8
ER
310# vim - "
311
f3f40db8
ER
312# minimum file size needed for compressed documents.
313# just smaller files than this get larger when compressed.
cdbfc157
ER
314# some stats:
315# - 0 byte file compressed was 25 bytes .gz
316# - 39 byte file was compressed as 57
317# - with test/test.spec@man 158 byte file was compressed also 158
318%_min_compress_bytes 159
f3f40db8 319
cd33aab7
AM
320#-----------------------------------------------------------------
321# find and gzip all files in %{_mandir} and %{infodir}
322#
323# Requires: xargs, find
324#
325#%no_install_post_compress_docs 1
326%__spec_install_post_compress_docs { \
f67bd19e 327%{!?no_install_post_compress_docs:__spec_install_post_compress_docs() { \
026ed59b 328 for i in /usr/share/man /usr/X11R6/man; do \
cd33aab7 329 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
026ed59b 330 echo "Compress man pages: $i"; \
f3f40db8
ER
331 find "$RPM_BUILD_ROOT$i" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
332 find "$RPM_BUILD_ROOT$i" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
38e531f0
ER
333 find $RPM_BUILD_ROOT$i -type l | while read a; do \
334 m=$(readlink $a); \
335 rm -f $a; \
336 echo .so ${m##*/} > $a; \
337 echo >&2 "Converted ${a#$RPM_BUILD_ROOT} from symlink to man link: ${m##*/}"; \
338 done; \
f3f40db8 339 find "$RPM_BUILD_ROOT$i" -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
cd33aab7
AM
340 fi; \
341 done; \
91bfff1c
JB
342 if [ -d "$RPM_BUILD_ROOT%{_infodir}" ]; then \
343 echo "Compress info pages: %{_infodir}"; \
344 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
345 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
346 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.info*' -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
026ed59b 347 fi; \
f67bd19e 348}; __spec_install_post_compress_docs } }
cd33aab7
AM
349
350#-----------------------------------------------------------------
351# Strip executable binaries and shared object files
352#
353# Requires: find, awk, strip, cut, xargs
354#
ee170415
JB
355# Special macros which affect this process:
356#%no_install_post_strip 1 # disable stripping at all
357#%_noautostrip regexp # exclude files matching (anchored!) regex from stripping
358#%_autostripall regexp # strip files matching (anchored!) regex using plain strip
359#%_autostripunneeded regexp # strip files matching (anchored!) regex using strip --strip-unneeded
360#%_autostripdebug regexp # strip files matching (anchored!) regex using strip --strip-debug
361#
cd33aab7 362%__spec_install_post_strip {%{!?debug: \
f67bd19e 363%{!?no_install_post_strip:__spec_install_post_strip() { \
65e03cc0 364if [ -d "$RPM_BUILD_ROOT" ]; then \
31bd34a8
ER
365 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
366 modulelist=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
fefadad0
ER
367 if [ "$modulelist" ]; then \
368 modulecount=$(echo "$modulelist" | wc -l); \
7f1d3873 369 printf "Stripping %d kernel modules..." $modulecount; \
6cf69412
ER
370 echo "$modulelist" | xargs -l512 chmod u+w; \
371 echo "$modulelist" | xargs -l512 %{__strip} --strip-unneeded --remove-section=.comment --remove-section=.note.GNU-stack; \
372 echo "DONE"; \
373 fi; \
31bd34a8 374 fi; \
559c4907 375 filelist=$(find $RPM_BUILD_ROOT -type f ! -regex ".*/usr/lib[0-9]*/debug/.*\.debug" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautostrip:! -regex "%{_noautostrip}"} %{?_autostripall:! -regex "%{_autostripall}"} %{?_autostripunneeded:! -regex "%{_autostripunneeded}"} %{?_autostripdebug:! -regex "%{_autostripdebug}"}); \
d65f5d0e
JB
376 if [ -n "$filelist" ]; then \
377 filetypes=`echo "$filelist" | xargs -r -d'\\n' file`; \
378 elfexelist=`echo "$filetypes" | awk -F: '/ELF.*executable/ {print $1}'`; \
379 elfsharedlist=`echo "$filetypes" | awk -F: '/LF.*shared object/ {print $1}'`; \
ee170415 380 archiveslist=`echo "$filetypes" | awk -F: '/current ar archive/ {print $1}'`; \
d65f5d0e 381 if [ -n "$elfexelist" ]; then \
fefadad0 382 printf "Stripping %d ELF executables..." $(echo "$elfexelist" | wc -l); \
d65f5d0e
JB
383 chmod u+w $elfexelist; \
384 %{__strip} --remove-section=.note --remove-section=.comment $elfexelist; \
385 echo "DONE"; \
386 fi; \
387 if [ -n "$elfsharedlist" ]; then \
fefadad0 388 printf "Stripping %d ELF shared libraries..." $(echo "$elfsharedlist" | wc -l); \
d65f5d0e
JB
389 chmod u+w $elfsharedlist; \
390 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $elfsharedlist; \
391 echo "DONE"; \
392 fi; \
393 if [ -n "$archiveslist" ]; then \
fefadad0 394 printf "Stripping %d ar archives..." $(echo "$archiveslist" | wc -l); \
d65f5d0e
JB
395 chmod u+w $archiveslist; \
396 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $archiveslist; \
397 echo "DONE"; \
398 fi; \
65e03cc0 399 fi; \
559c4907
ER
400 filelist_all=%{?_autostripall:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripall}")}; \
401 filelist_unneeded=%{?_autostripunneeded:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripunneeded}")}; \
402 filelist_debug=%{?_autostripdebug:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripdebug}")}; \
d65f5d0e 403 if [ -n "$filelist_all" ]; then \
fefadad0 404 printf "Stripping everything from %d additional files..." $(echo "$filelist_all" | wc -l); \
ee170415 405 chmod u+w $filelist_all; \
d65f5d0e 406 %{__strip} --remove-section=.note --remove-section=.comment $filelist_all; \
fc87add2 407 echo "DONE"; \
cd33aab7 408 fi; \
d65f5d0e 409 if [ -n "$filelist_unneeded" ]; then \
fefadad0 410 printf "Stripping unneeded from %d additional files..." $(echo "$filelist_unneeded" | wc -l); \
ee170415 411 chmod u+w $filelist_unneeded; \
d65f5d0e 412 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $filelist_unneeded; \
fc87add2 413 echo "DONE"; \
5b0f0ac9 414 fi; \
d65f5d0e 415 if [ -n "$filelist_debug" ]; then \
fefadad0 416 printf "Stripping debuginfo from %d additional files..." $(echo "$filelist_debug" | wc -l); \
ee170415 417 chmod u+w $filelist_debug; \
d65f5d0e 418 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $filelist_debug; \
fc87add2 419 echo "DONE"; \
f80cefa3 420 fi; \
f67bd19e 421fi; }; __spec_install_post_strip } } }
31b569b6 422
cc545e1a 423#-----------------------------------------------------------------
424# remove all RPATH from executable binaries and shared object files
425#
426# Requires: find, awk, cut, xargs, chrpath, uname
427#
ee170415
JB
428# Special macros which affect this process
429#%no_install_post_chrpath 1 # disable chrpath at all
430#%_noautochrpath regex # exclude files matching (anchored!) regex from chrpath
431#
cc545e1a 432%__spec_install_post_chrpath {%{!?debug: \
f67bd19e 433%{!?no_install_post_chrpath: __spec_install_post_chrpath() { \
f80cefa3 434if [ -d "$RPM_BUILD_ROOT" ]; then \
559c4907 435 files=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautochrpath:! -regex "%{_noautochrpath}"}`; \
65e03cc0 436 if [ -n "$files" ]; then \
0faed11b 437 objs=`echo "$files" | xargs -r -d'\\n' file | awk -F: '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}'`; \
fd3a42b0 438 fi; \
65e03cc0 439 if [ -n "$objs" ]; then \
fefadad0 440 printf "Remove RPATH from %d executable binaries and shared object files.\n" $(echo "$objs" | wc -l); \
65e03cc0
ER
441 echo "$objs" | \
442 while read file; do \
443 rpath= ; \
444 chmod u+w "$file"; \
445 for dir in `chrpath -l "$file" | \
446 awk '/RPATH=/ { gsub(/.*RPATH=/,""); gsub(/:/," "); print $0 }'` ; do \
447 case $dir in \
448 /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
449 echo "remove-rpath: $dir in $file"; \
450 ;; \
451 * ) \
452 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
453 else rpath="$rpath:$dir" ; fi ; \
454 ;; \
455 esac ; \
456 done ; \
457 if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
458 else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
459 done; \
460 fi; \
f67bd19e 461fi; }; __spec_install_post_chrpath } } }
31b569b6 462
22a54b3e 463#-----------------------------------------------------------------
93b46c00 464# Find and gzip all kernel modules
465#
466# Requires: find
467#
43f81f06 468#%no_install_post_compress_modules 1
93b46c00 469%__spec_install_post_compress_modules { \
f67bd19e 470%{!?no_install_post_compress_modules: __spec_install_post_compress_modules() { \
9cf7c1b9 471 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
9cf7c1b9 472 q=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
fefadad0
ER
473 if [ "$q" ]; then \
474 printf "Compress %d kernel modules..." $(echo "$q" | wc -l); \
475 echo "$q" | xargs -r %{__gzip} -9nf; \
476 echo "DONE"; \
477 find $RPM_BUILD_ROOT/lib/modules -name '*o' -type l -printf "%p %l\n" | \
478 while read a b; do ln -sf $b.gz $a.gz; rm -f $a; done; \
479 fi; \
31b569b6 480 fi; \
f67bd19e 481}; __spec_install_post_compress_modules } }
cd33aab7 482
e4d71427
ER
483# Remove common Perl files we don't package
484%__spec_install_post_perl_clean {\
485%{!?no_install_post_perl_clean: \
486%{?pdir:rm -f $RPM_BUILD_ROOT{%{perl_archlib}/perllocal.pod,%{perl_vendorarch}/auto/%{pdir}%{?pnam:/%(echo %{pnam} | tr - /)}/.packlist}} \
487} }
488
aad1c8e4 489#-----------------------------------------------------------------
cc6c554c 490# Update GConf2 schemas
aad1c8e4 491#
492# Requires: GConf2
493#
5b8ed3c0 494%gconf_schema_install() \
31b569b6 495 umask 022; \
2b633092
ER
496 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null; \
497%{nil}
5b8ed3c0 498
499%gconf_schema_uninstall() \
429d047e 500if [ $1 = 0 ]; then \
31b569b6
ER
501 umask 022; \
502 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
2b633092 503fi; \
429d047e 504%{nil}
505
506#-----------------------------------------------------------------
507# Update desktop MIME database
96999189 508# requires: desktop-file-utils
7ec40643 509%update_desktop_database() {{ \
429d047e 510 umask 022; \
db1adf13 511 /usr/bin/update-desktop-database -q; \
c6f21aa8 512}}%{nil}
429d047e 513
7ec40643
ER
514%update_desktop_database_post %update_desktop_database
515
516%update_desktop_database_postun() {{ \
2b633092 517if [ "$1" = "0" ]; then \
7ec40643 518 %update_desktop_database; \
2b633092 519fi; \
c6f21aa8 520}}%{nil}
429d047e 521
db1adf13 522#-----------------------------------------------------------------
523# Update shared MIME info database
524# requires: shared-mime-info
525#
7ec40643 526%update_mime_database() {{ \
db1adf13 527 umask 022; \
528 /usr/bin/update-mime-database %{_datadir}/mime; \
c6f21aa8 529}}%{nil}
db1adf13 530
531#-----------------------------------------------------------------
532# Update icon cache
533# requires: gtk+
534#
7ec40643 535%update_icon_cache() {{ \
db1adf13 536 umask 022; \
8ffd1cc2 537 /usr/bin/gtk-update-icon-cache -qf %{_datadir}/icons/%1; \
c6f21aa8 538}}%{nil}
db1adf13 539
429d047e 540#-----------------------------------------------------------------
541# Update scrollkeeper database
542# requires: scrollkeeper
543#
544%scrollkeeper_update_post() \
429d047e 545 /usr/bin/scrollkeeper-update -q; \
2b633092 546%{nil}
429d047e 547
548%scrollkeeper_update_postun() \
2b633092 549if [ "$1" = "0" ]; then \
429d047e 550 /usr/bin/scrollkeeper-update -q; \
2b633092 551fi; \
429d047e 552%{nil}
553
cd33aab7
AM
554#-----------------------------------------------------------------
555# post %install sequence:
556# - autodeps exceptions
557# - compress all man and info pages,
558# - strip all ELF executables and ELF shared objects if not %debug.
5b0f0ac9 559# - compress kernel modules if any
cd33aab7
AM
560
561###################################################################
562# Requires/Provides automation
563# exceptions system by Jacek Konieczny <jajcus@pld.org.pl>
a4852742 564#
fbbdca08
JB
565%__noautoreqfiles %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
566%__noautoprovfiles %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
567%__noautoreq %(sed -e s'/#.*//' /etc/rpm/noautoreq)%{?_noautoreq: %{_noautoreq}}
568%__noautoreqdep %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
569%__noautoprov %(sed -e s'/#.*//' /etc/rpm/noautoprov)%{?_noautoprov: %{_noautoprov}}
a1551c98 570
a4852742
JB
571#%_noautocompressdoc %{nil}
572#
5b0f0ac9
MM
573%_missing_doc_files_terminate_build 1%{nil}
574%_unpackaged_files_terminate_build %{nil}
4c7d3ba4 575# (X)emacs support
42b7e5ac 576%___emacs_lispdir_helper -batch -q -eval '(while load-path (princ (concat (car load-path) "\\n")) (setq load-path (cdr load-path)))' 2> /dev/null|sed -n '/\\(.*\\/x\\?emacs\\/site-lisp\\)\\/\\?$/{s,,\\1,p;q;}'
a1551c98
ER
577%_emacs_lispdir %{expand:%%global _emacs_lispdir %(Z=$(emacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_emacs_lispdir
578%_xemacs_lispdir %{expand:%%global _xemacs_lispdir %(Z=$(xemacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_xemacs_lispdir
41a62699 579
984f6de6
JK
580%__php_provides %{nil}
581%__php_requires %{nil}
582%__perl_provides %{nil}
583%__perl_requires %{nil}
63b0a9d7 584%__mono_provides %{nil}
585%__mono_requires %{nil}
41a62699
AF
586
587# Perl specific macro definitions.
a1551c98
ER
588%perl_privlib %{expand:%%global perl_privlib %(eval $(%{__perl} -V:installprivlib 2>/dev/null); echo ${installprivlib:-ERROR})}%perl_privlib
589%perl_archlib %{expand:%%global perl_archlib %(eval $(%{__perl} -V:installarchlib 2>/dev/null); echo ${installarchlib:-ERROR})}%perl_archlib
590%perl_vendorlib %{expand:%%global perl_vendorlib %(eval $(%{__perl} -V:installvendorlib 2>/dev/null); echo ${installvendorlib:-ERROR})}%perl_vendorlib
591%perl_vendorarch %{expand:%%global perl_vendorarch %(eval $(%{__perl} -V:installvendorarch 2>/dev/null); echo ${installvendorarch:-ERROR})}%perl_vendorarch
592%perl_sitelib %{expand:%%global perl_sitelib %(eval $(%{__perl} -V:installsitelib 2>/dev/null); echo ${installsitelib:-ERROR})}%perl_sitelib
593%perl_sitearch %{expand:%%global perl_sitearch %(eval $(%{__perl} -V:installsitearch 2>/dev/null); echo ${installsitearch:-ERROR})}%perl_sitearch
41a62699 594
cb84f517 595# Ruby
a1551c98
ER
596%__ruby /usr/bin/ruby
597%ruby_archdir %{expand:%%global ruby_archdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["archdir"]' 2>/dev/null || echo ERROR)}%ruby_archdir
598%ruby_ridir %{expand:%%global ruby_ridir %(%{__ruby} -r rbconfig -e 'include Config; print File.join(CONFIG["datadir"], "ri", CONFIG["ruby_version"], "system")' 2>/dev/null || echo ERROR)}%ruby_ridir
599%ruby_rubylibdir %{expand:%%global ruby_rubylibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["rubylibdir"]' 2>/dev/null || echo ERROR)}%ruby_rubylibdir
600%ruby_vendorarchdir %{expand:%%global ruby_vendorarchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorarchdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorarchdir
601%ruby_vendorlibdir %{expand:%%global ruby_vendorlibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorlibdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorlibdir
602%ruby_sitearchdir %{expand:%%global ruby_sitearchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitearchdir"]' 2>/dev/null || echo ERROR)}%ruby_sitearchdir
603%ruby_sitelibdir %{expand:%%global ruby_sitelibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitelibdir"]' 2>/dev/null || echo ERROR)}%ruby_sitelibdir
604%ruby_version %{expand:%%global ruby_version %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["ruby_version"]' 2>/dev/null || echo ERROR)}%ruby_version
5483bb35
ER
605%ruby_ver_requires_eq Requires: ruby(ver) = %ruby_version
606%ruby_mod_ver_requires_eq Requires: ruby-modules(ver) = %ruby_version
cb84f517 607
3da52f86 608%php_pear_dir /usr/share/pear
a1551c98
ER
609%php_extensiondir %{expand:%%global php_extensiondir %(php-config --extension-dir 2>/dev/null || echo ERROR)}%php_extensiondir
610%php_sysconfdir %{expand:%%global php_sysconfdir %(php-config --sysconfdir 2>/dev/null || echo ERROR)}%php_sysconfdir
611%php_includedir %{expand:%%global php_includedir %(php-config --include-dir 2>/dev/null || echo ERROR)}%php_includedir
41a62699 612
f73da51b 613# extract php/zend api versions
a1551c98
ER
614%php_major_version %{expand:%%global php_major_version %(awk '/#define PHP_MAJOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)}%php_major_version
615%php_api_version %{expand:%%global php_api_version %(awk '/#define PHP_API_VERSION/{print $3}' %{php_includedir}/main/php.h 2>/dev/null || echo ERROR)}%php_api_version
616%php_pdo_api_version %{expand:%%global php_pdo_api_version %(awk '/#define PDO_DRIVER_API/{print $3}' %{php_includedir}/ext/pdo/php_pdo_driver.h 2>/dev/null || echo ERROR)}%php_pdo_api_version
617%php_debug %{expand:%%global php_debug %(awk '/#define ZEND_DEBUG/{print $3}' %{php_includedir}/main/php_config.h 2>/dev/null || echo ERROR)}%php_debug
618%zend_module_api %{expand:%%global zend_module_api %(awk '/#define ZEND_MODULE_API_NO/{print $3}' %{php_includedir}/Zend/zend_modules.h 2>/dev/null || echo ERROR)}%zend_module_api
619%zend_extension_api %{expand:%%global zend_extension_api %(awk '/#define ZEND_EXTENSION_API_NO/{print $3}' %{php_includedir}/Zend/zend_extensions.h 2>/dev/null || echo ERROR)}%zend_extension_api
620%zend_zts %{expand:%%global zend_zts %(Z=$(grep -sc '^#define ZTS 1' %{php_includedir}/main/php_config.h); echo ${Z:-ERROR})}%zend_zts
6b2157a6
ER
621
622# helper macro
e255dfdc 623%__php_api_requires(v:) Requires: php%{-v*}(%{expand:%1}) = %{expand:%{%{!?2:%{1}}%{?2}}}
6b2157a6
ER
624
625# macros for public use
626# for php extensions (php-pecl)
ab8d73ee 627%requires_php_extension %{__php_api_requires modules_api php_api_version} \
cc2b296f 628%{__php_api_requires zend_module_api} \
e255dfdc
ER
629%{__php_api_requires -v %php_major_version debug php_debug} \
630%{__php_api_requires -v %php_major_version thread-safety zend_zts}
ab8d73ee 631
6b2157a6
ER
632# for zend extensions
633%requires_zend_extension %{__php_api_requires zend_module_api} \
ab8d73ee 634%{__php_api_requires zend_extension_api} \
e255dfdc
ER
635%{__php_api_requires -v %php_major_version debug php_debug} \
636%{__php_api_requires -v %php_major_version thread-safety zend_zts}
6b2157a6 637
1c107a2d
ER
638# for php pdo modules (php-pecl-PDO_*)
639%requires_php_pdo_module %{__php_api_requires PDO_API php_pdo_api_version}
640
e6ca24e8
ER
641# for using PHP post scripts. for PHP >= 5.0
642%php_webserver_restart \
643[ ! -f /etc/apache/conf.d/??_mod_php.conf ] || %service -q apache restart \
febce2c9 644[ ! -f /etc/httpd/conf.d/??_mod_php.conf ] || %service -q httpd restart \
b4080c85
ER
645if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
646 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
647 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php.fcgi* ]]; then \
648 %service -q php-fcgi restart \
649 fi \
650fi \
e6ca24e8
ER
651%{nil}
652
653# for using php post scripts. for PHP >= 4.0 && PHP < 5.0
654%php4_webserver_restart \
655[ ! -f /etc/apache/conf.d/??_mod_php4.conf ] || %service -q apache restart \
febce2c9 656[ ! -f /etc/httpd/conf.d/??_mod_php4.conf ] || %service -q httpd restart \
b4080c85
ER
657if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
658 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
659 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php4.fcgi* ]]; then \
660 %service -q php-fcgi restart \
661 fi \
662fi \
e6ca24e8
ER
663%{nil}
664
b89f672e
AM
665
666# X.org helper macros
04336b74 667%__xorg_abi_requires() Requires: xorg-xserver-server(%{expand:%1}-abi) = %{expand:%{%{!?2:%{1}}%{?2}}}
b89f672e 668#
a1551c98
ER
669%xorg_xserver_ansic_abi %{expand:%%global xorg_xserver_ansic_abi %(awk '/#define ABI_ANSIC_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_ansic_abi
670%xorg_xserver_extension_abi %{expand:%%global xorg_xserver_extension_abi %(awk '/#define ABI_EXTENSION_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_extension_abi
671%xorg_xserver_font_abi %{expand:%%global xorg_xserver_font_abi %(awk '/#define ABI_FONT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null | echo ERROR)}%xorg_xserver_font_abi
672%xorg_xserver_videodrv_abi %{expand:%%global xorg_xserver_videodrv_abi %(awk '/#define ABI_VIDEODRV_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_videodrv_abi
673%xorg_xserver_xinput_abi %{expand:%%global xorg_xserver_xinput_abi %(awk '/#define ABI_XINPUT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_xinput_abi
b89f672e
AM
674
675%requires_xorg_xserver_extension %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
676%{__xorg_abi_requires extension xorg_xserver_extension_abi}
677%requires_xorg_xserver_xinput %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
678%{__xorg_abi_requires xinput xorg_xserver_xinput_abi}
679%requires_xorg_xserver_font %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
680%{__xorg_abi_requires font xorg_xserver_font_abi}
681%requires_xorg_xserver_videodrv %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
682%{__xorg_abi_requires videodrv xorg_xserver_videodrv_abi}
683
41a62699
AF
684# Python specific macro definitions.
685# python main version
a1551c98 686%py_ver %{expand:%%global py_ver %(%{__python} -c "import sys; print sys.version[:3]" || echo ERROR)}%py_ver
41a62699
AF
687
688# directories
a1551c98 689%py_prefix %{expand:%%global py_prefix %(%{__python} -c "import sys; print sys.prefix" || echo ERROR)}%py_prefix
31b569b6 690%py_libdir %{py_prefix}/%{_lib}/python%{py_ver}
a4f0b5e0 691%py_scriptdir %{py_prefix}/share/python%{py_ver}
31b569b6 692%py_incdir /usr/include/python%{py_ver}
3da52f86 693%py_sitedir %{py_libdir}/site-packages
a4f0b5e0 694%py_sitescriptdir %{py_scriptdir}/site-packages
31b569b6 695%py_dyndir %{py_libdir}/lib-dynload
41a62699
AF
696
697# pure python modules compilation
31b569b6 698%py_comp python -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
41a62699 699
31b569b6 700%py_ocomp python -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
41a62699
AF
701
702# Software written in Python language require Python with main version
5177c7b1 703%pyrequires_eq() Requires: %1
41a62699 704
ea4b2900
AF
705# Hardlink binary identical .pyc and .pyo files
706# (idea by glen <at> pld-linux <dot> org)
707%__spec_install_post_py_hardlink {\
f67bd19e 708%{!?no_install_post_py_hardlink: __spec_install_post_py_hardlink() { \
ea4b2900 709[ ! -d "$RPM_BUILD_ROOT" ] || find "$RPM_BUILD_ROOT" -name '*.pyc' | while read a; do \
455bd3f1 710 b="${a%.pyc}.pyo"; \
ea4b2900
AF
711 if cmp -s "$a" "$b"; then \
712 ln -f "$a" "$b"; \
713 fi; \
714done \
f67bd19e 715}; __spec_install_post_py_hardlink } }
ea4b2900 716
16f6f416 717# remove python sources, so that check-files won't complain
ea4b2900
AF
718# (idea by glen <at> pld-linux <dot> org)
719%py_postclean() \
e4e8948b 720for d in %{py_sitescriptdir} %{py_sitedir} %*; do \
9ba5542a 721 [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
ea4b2900
AF
722done \
723%{nil}
724
67ed5b97 725# depmod macro
726%depmod() { \
fe30b3ea 727umask 022; \
67ed5b97 728if [ -e /boot/System.map-%1 ]; then \
31b569b6 729 /sbin/depmod -a -F /boot/System.map-%1 %1; \
67ed5b97 730else \
31b569b6
ER
731 if [ -e /boot/System.map ]; then \
732 /sbin/depmod -a -F /boot/System.map %1; \
733 else \
734 /sbin/depmod -a %1; \
735 fi \
67ed5b97 736fi; \
737}
738
495892af 739# XMMS specific macros
a1551c98
ER
740%xmms_prefix %{expand:%%global xmms_prefix %(xmms-config --prefix 2>/dev/null || echo ERROR)}%xmms_prefix
741%xmms_exec_prefix %{expand:%%global xmms_exec_prefix %(xmms-config --exec-prefix 2>/dev/null || echo ERROR)}%xmms_exec_prefix
742%xmms_version %{expand:%%global xmms_version %(xmms-config --version 2>/dev/null || echo ERROR)}%xmms_version
743%xmms_datadir %{expand:%%global xmms_datadir %(xmms-config --data-dir 2>/dev/null || echo ERROR)}%xmms_datadir
744%xmms_plugindir %{expand:%%global xmms_plugindir %(xmms-config --plugin-dir 2>/dev/null || echo ERROR)}%xmms_plugindir
745%xmms_visualization_plugindir %{expand:%%global xmms_visualization_plugindir %(xmms-config --visualization-plugin-dir 2>/dev/null || echo ERROR)}%xmms_visualization_plugindir
746%xmms_input_plugindir %{expand:%%global xmms_input_plugindir %(xmms-config --input-plugin-dir 2>/dev/null || echo ERROR)}%xmms_input_plugindir
747%xmms_output_plugindir %{expand:%%global xmms_output_plugindir %(xmms-config --output-plugin-dir 2>/dev/null || echo ERROR)}%xmms_output_plugindir
748%xmms_effect_plugindir %{expand:%%global xmms_effect_plugindir %(xmms-config --effect-plugin-dir 2>/dev/null || echo ERROR)}%xmms_effect_plugindir
749%xmms_general_plugindir %{expand:%%global xmms_general_plugindir %(xmms-config --general-plugin-dir 2>/dev/null || echo ERROR)}%xmms_general_plugindir
750
751%_target_base_arch %{expand:%%global _target_base_arch %(echo %{_target_cpu} | sed 's/i.86/i386/;s/athlon/i386/;s/pentium./i386/;s/amd64/x86_64/;s/ia32e/x86_64/')}%_target_base_arch
bb128216 752
e3618ee9 753# user/group checking macros
754#
755# Usage:
756# %userremove myuser
757#
758%userremove /usr/lib/rpm/user_group.sh user del
759%groupremove /usr/lib/rpm/user_group.sh group del
760#
761# Usage:
762# if %usertestrm myuser; then
763# /usr/sbin/userdel -r myuser
764# Note:
765# use these macros only if you need to call userdel/groupdel with
766# a non-standard option or take an extra action; otherwise use the
767# %userremove/%groupremove macros
768#
769%usertestrm /usr/lib/rpm/user_group.sh user testrm
770%grouptestrm /usr/lib/rpm/user_group.sh group testrm
13f70a2c
JK
771# user group membership management macros
772#
773# Usage:
774# %addusertogroup myuser agroup
775#
776%addusertogroup /usr/lib/rpm/user_group.sh user addtogroup
bfd9689c 777
778# banner support (useful in {pre,post}{,un} and triggers)
779#
780# Usage:
a980efc1 781# %banner name [-a] [-e] [-n] [-tn] <<EOF
bfd9689c 782# the banner text, the banner text
a980efc1
ER
783# the banner text, and following line
784#EOF
785# You can use any form of here-document, <<'EOF' <<-EOT will do.
786# NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
787#
bfd9689c 788# -a - append to the banner
fb033326 789# -e - send to stderr instead of stdout
1257c400 790# -n - no show banner (overrides -t)
791# -t - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
4055114a
ER
792#
793# Tests:
794# (rpm -E '%banner -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m
795# rpm -E 'date | %banner -e banner' > m; sh -x m
796#
8bea2501 797%banner(aent:) ( \
f1bbc6ff 798RPM_SCRIPTVERBOSITY=5 \
799[ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
800if [ -x /usr/bin/banner.sh ]; then \
a980efc1 801 CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
f1bbc6ff 802else \
fb033326 803 CMD="cat%{-e: >&2}" \
f1bbc6ff 804fi \
4055114a
ER
805eval $CMD %{?2:%2}%{?3: %3}) \
806%{nil}
1257c400 807
3c972982 808# useradd/groupadd macros
1ebc460a 809# Author: Elan Ruusamäe <glen@pld-linux.org>
29c5556c
ER
810#
811# Usage:
812# %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
813# [-g initial_group] [-G group[,...]] login
814#
815# -u uid. REQUIRED
816# -g gid/group. REQUIRED
817# -s defaults to /bin/false
818# -d defaults to /usr/share/empty
819# -c No default
820# -r is accepted but ignored (it's always set)
6eb25d5d 821# -k skeleton dir. defaults to /usr/share/empty
29c5556c
ER
822# rpm specific flags
823# -P package name. defaults to %{name}
824#
29c5556c 825%useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
0044d46f
ER
826%{!-u:%{error:useradd: Required argument -u missing}} \
827%{!-g:%{error:useradd: Required argument -g missing}} \
828%{!?1:%{error:useradd: Required parameter login missing}} \
29c5556c
ER
829if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
830 if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
831 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
832 exit 1 \
833 fi \
834else \
835 echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
836 /usr/sbin/useradd \\\
cc333c8b 837 %{-m:-m -k %{-k*}%{!-k:/usr/share/empty}} \\\
29c5556c
ER
838 -u %{-u*} \\\
839 -r \\\
840 -d %{-d*}%{!-d:/usr/share/empty} \\\
841 -s %{-s*}%{!-s:/bin/false} \\\
85e3e9a1 842 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
29c5556c
ER
843 -g %{-g*} \\\
844 %{-M} \\\
845 %{-G:-G %{-G*}} \\\
6750d9f5 846 %{expand:%{%{#}}} 1>&2 || exit $? \
52e30914 847 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i passwd || : \
29c5556c
ER
848fi;
849
29c5556c
ER
850# Usage:
851# %groupadd [-P package] [-g gid] group
852#
853# -g gid. REQUIRED
854#
855# Sample:
856# %groupadd -P %{name}-base -g %{gid} %{name}
857
858%groupadd(g:P:rfo) \
0044d46f
ER
859%{!-g:%{error:groupadd: Required argument -g missing}} \
860%{!?1:%{error:groupadd: Required parameter group missing}} \
29c5556c
ER
861if [ -n "`/usr/bin/getgid %{1}`" ]; then \
862 if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
863 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
864 exit 1 \
865 fi \
866else \
867 echo "Adding group %{1} GID=%{-g*}." \
6750d9f5 868 /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 || exit $? \
52e30914 869 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i group || : \
29c5556c 870fi;
053b8de1 871
55a50f1a 872# webapp macros
1ebc460a 873# Author: Elan Ruusamäe <glen@pld-linux.org>
ba42a822
ER
874#
875# The config is installed/removed inside trigger, this means that you can any
876# time install apache1/apache/lighttpd package and the configuration file is
43f81f06 877# updated. if you don't need the config for various reason for specific
ba42a822
ER
878# webserver, just remove the symlink from config directory using webapp
879# program. the trigger will not recreate the symlink on upgrades. In other
880# words the config is linked to webserver config directory on first install of
881# PACKAGE or WEBSERVER.
882#
55a50f1a
ER
883# Add package's webserver config to webserver webapps dir.
884# Usage:
217f2cb2 885# %webapp_register WEBSERVER WEBAPP
ba42a822
ER
886#
887%webapp_register() \
888%{?debug:set -x; echo "webapp_register: %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
889if [ "$1" = "1" ] && [ "$2" = "1" ]; then\
890 /usr/sbin/webapp register %1 %2\
891fi\
973c1dc7 892# reload webserver if the config symlink is there and skip reload if webserver is upgraded\
afe4f5f0 893if [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ] && [ "$2" -lt "2" ]; then\
5f0b2e29 894 %{expand:%service -q %%1 reload}\
ba42a822
ER
895fi\
896%{nil}
897
898# Remove package's config from webserver webapps dir.
ba42a822 899# Usage:
b9588fe6
ER
900# %webapp_register [-f] WEBSERVER WEBAPP
901%webapp_unregister(f) \
ba42a822
ER
902%{?debug:set -x; echo "webapp_unregister: %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
903# remove link if either of the packages are gone \
afe4f5f0 904if [ -n "%{-f:1}" ] || [ "$1" = "0" ] || [ "$2" = "0" ] && [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ]; then \
217f2cb2 905 /usr/sbin/webapp unregister %1 %2\
5f0b2e29 906 %{expand:%service -q %%1 reload}\
ba42a822
ER
907fi \
908%{nil}
909
8edf8498 910# service macro.
1ebc460a 911# Author: Elan Ruusamäe <glen@pld-linux.org>
8edf8498
ER
912#
913# calls usual service restart on package %post, but skips the restart if
914# administrator has disabled automatic service restarts in either global
915# /etc/sysconfig/rpm or per service /etc/sysconfig/SERVICE file.
916#
8edf8498 917# Usage:
524e081b 918# %service [-q] SERVICE ACTION ["SERVICE NICE DESCRIPTION"]
8edf8498 919#
dd4e969a 920# -q be silent when service isn't started (for scriplets restaring other package's services)
8edf8498 921#
e42cbd35 922%service(q) {{%(export quiet=%{-q:1}; /usr/lib/rpm/service_generator.sh %{*}) };}
cec3a041
ER
923
924
91bd3172
ER
925# Java macros. based on jpackage macros.java
926#
927# Root directory where all Java VMs/SDK/JREs are installed.
93406dd9 928%_jvmdir %{_libdir}/jvm
91bd3172
ER
929
930# Root directory where all Java VMs/SDK/JREs expose their jars
93406dd9 931%_jvmjardir %{_libdir}/jvm-exports
91bd3172
ER
932
933# Root directory for all Java VM/SDK/JRE's private things.
934%_jvmprivdir %{_libdir}/jvm-private
935
936# Root directory for all architecture dependent parts of Java VM/SDK/JRE's
93406dd9 937%_jvmlibdir %{_libdir}/jvm
91bd3172
ER
938
939# Root directory for all architecture independent parts of Java VM/SDK/JRE's
940%_jvmdatadir %{_datadir}/jvm
941
942# Root directory for all configurations parts of Java VM/SDK/JRE's
943%_jvmsysconfdir %{_sysconfdir}/jvm
944
945# Root directory for all common architecture dependent parts of Java VM/SDK/JRE's
29959405 946%_jvmcommonlibdir %{_libdir}/jvm-common
91bd3172
ER
947
948# Root directory for all common architecture independent parts of Java VM/SDK/JRE's
29959405 949%_jvmcommondatadir %{_datadir}/jvm-common
91bd3172
ER
950
951# Root directory for all common configurations parts of Java VM/SDK/JRE's
29959405 952%_jvmcommonsysconfdir %{_sysconfdir}/jvm-common
91bd3172
ER
953
954# Directory where arch-specific (JNI) version-independent jars are installed.
93406dd9 955%_jnidir %{_libdir}/java
91bd3172 956
a1551c98 957%java_home %{expand:%%global java_home %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVA_HOME; . %{_javadir}-utils/java-functions; set_jvm; echo ${JAVA_HOME:-ERROR})}%java_home
cec3a041 958
43f81f06
ER
959%ant JAVA_HOME=%{java_home} ant
960%jar %{java_home}/bin/jar
a1551c98 961%java %{expand:%%global java %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVACMD; . %{_javadir}-utils/java-functions; set_javacmd; echo $JAVACMD)}%java
43f81f06
ER
962%javac %{java_home}/bin/javac
963%javadoc %{java_home}/bin/javadoc
cec3a041 964
43f81f06 965%add_jvm_extension JAVA_LIBDIR=%{buildroot}/%{_javadir} %{_bindir}/jvmjar -l
cec3a041
ER
966
967%jpackage_script() \
a2047fce
ER
968install -d $RPM_BUILD_ROOT%{_bindir}\
969cat > $RPM_BUILD_ROOT%{_bindir}/%5 << 'EOF' \
cec3a041
ER
970#!/bin/sh\
971#\
972# %{name} script\
973# JPackage Project <http://www.jpackage.org/>\
974\
975# Source functions library\
976. %{_javadir}-utils/java-functions\
977\
978# Source system prefs\
a2047fce 979if [ -f %{_sysconfdir}/java/%{name}.conf ]; then\
43f81f06 980 . %{_sysconfdir}/java/%{name}.conf\
cec3a041
ER
981fi\
982\
983# Source user prefs\
a2047fce
ER
984if [ -f $HOME/.%{name}rc ]; then\
985 . $HOME/.%{name}rc\
cec3a041
ER
986fi\
987\
988# Configuration\
989MAIN_CLASS=%1\
990BASE_FLAGS=%2\
991BASE_OPTIONS=%3\
a2047fce 992BASE_JARS="%(echo %4 | tr ':' ' ')"\
cec3a041
ER
993\
994# Set parameters\
995set_jvm\
a2047fce
ER
996set_classpath $BASE_JARS\
997set_flags $BASE_FLAGS\
998set_options $BASE_OPTIONS\
cec3a041
ER
999\
1000# Let's start\
a2047fce 1001run "$@"\
cec3a041
ER
1002EOF
1003
d449d2c8
ER
1004# jpackage 1.7
1005# Directory for maven depmaps
1006#
1007%_mavendepmapdir /etc/maven
1008%_mavendepmapfragdir /etc/maven/fragments
1009
1010#
1011# add_to_depmap adds an entry to the depmap. The arguments are:
1012#
1013# %1 the original groupid
1014# %2 the original artifact id
1015# %3 the version
1016# %4 the new groupid
1017# %5 the new artifactid
1018#
1019
1020%add_to_maven_depmap() \
1021install -dm 755 $RPM_BUILD_ROOT/%{_mavendepmapfragdir}\
1022cat >>$RPM_BUILD_ROOT/%{_mavendepmapfragdir}/%{name}<< EOF\
1023<dependency>\
1024 <maven>\
1025 <groupId>%1</groupId>\
1026 <artifactId>%2</artifactId>\
1027 <version>%3</version>\
1028 </maven>\
1029 <jpp>\
1030 <groupId>%4</groupId>\
1031 <artifactId>%5</artifactId>\
1032 <version>%3</version>\
1033 </jpp>\
1034</dependency>\
1035\
1036EOF\
1037%{nil}
1038
1039#==============================================================================
1040#
1041# update_maven_depmap updates the main maven depmap
1042#
1043%update_maven_depmap() \
1044echo -e "<dependencies>\\n" > %{_mavendepmapdir}/maven2-depmap.xml\
1045if [ -d %{_mavendepmapfragdir} ] && [ -n "`find %{_mavendepmapfragdir} -type f`" ]; then\
1046cat %{_mavendepmapfragdir}/* >> %{_mavendepmapdir}/maven2-depmap.xml\
1047fi\
1048echo -e "</dependencies>\\n" >> %{_mavendepmapdir}/maven2-depmap.xml
1049
1050
e22fc3d1 1051# PEAR install macros
1ebc460a 1052# Author: Elan Ruusamäe <glen@pld-linux.org>
d2a29d34
ER
1053#
1054# Usage:
1055# %%pear_package_setup [-a #] [-n FMT]
1056#
e22fc3d1 1057# -a # - also unpack SOURCE#. for PEAR bootstrapping
d2a29d34 1058# -n FMT - create builddir with FMT, instead of default %%{_pearname}-%%{version}
e22fc3d1 1059# -z - unpack pear package and let pear use package.xml (not tarball) for install. for PEAR bootstrapping
d2a29d34
ER
1060#
1061# unpack PEAR package to %%{_builddir}/FMT. package is extracted with already
1062# destination hierarchy. you should copy the tree to buildroot after
1063# patching/reorganizing with %%pear_package_install.
1064#
1065# additionally BUILDROOT is stripped from files and files are converted to UNIX
1066# line endings.
1067#
1068# the pear install process output is recorded to install.log, you should put it
a4f06f46 1069# to %%doc for later debug or just for information.
d2a29d34
ER
1070#
1071# additionally additional-packages.txt is produced if it was detected that the
1072# package has optional dependencies. the file format is suitable of displaying
1073# in %%post of a package. you should put this file to %%doc. noautocompressdoc is
1074# automatically added for this file.
e22fc3d1
ER
1075
1076
1077# records install.log and transforms PEAR names to PLD Linux rpm package names.
1078%__pear_install_log \
1079tee install.log \
1080# make post message of optional packages \
1081grep 'can optionally use' install.log | sed -e 's,package "pear/,package "php-pear-,g;s,^pear/,php-pear-,' > optional-packages.txt \
1082if [ -s optional-packages.txt ]; then \
1083 awk -F'"' '/use package/{print $2}' optional-packages.txt | sed -e "s,_,/,g;s,php-pear-, 'pear(,;s,$,.*)'," | tr -d '\\\n' > _noautoreq \
1084else \
1085 rm -f optional-packages.txt \
1086fi \
1087%{nil}
1088
1089# command invoking pear cli
1090%__pear /usr/bin/pear
1091
856feeea 1092%pear_install(a:n:zD) \
e22fc3d1
ER
1093%__pear \\\
1094 -c pearrc \\\
d2a29d34
ER
1095 -d doc_dir=/docs \\\
1096 -d php_dir=%{php_pear_dir} \\\
1097 -d bin_dir=%{_bindir} \\\
1098 -d data_dir=%{php_pear_dir}/data \\\
1099 -d test_dir=%{php_pear_dir}/tests \\\
1100 install \\\
e22fc3d1 1101 --packagingroot=%{builddir} \\\
d2a29d34
ER
1102 --offline \\\
1103 --nodeps \\\
1104 %{-f:--force} \\\
856feeea
ER
1105 %{!-z:%{S:%{-a*}%{!-a:0}}}%{-z:$_P} > .install.log || { c=$?; cat .install.log; exit $c; }; \
1106%{nil}
1107
1108# The main macro.
1109# using this macro will append optional-packages.txt to the nocompressdoc list
1110# as it's displayed to user after package install. and adding additional gzip
1111# dep is just waste ;)
1112%pear_package_setup(a:n:zD) \
1113%define srcdir %{-n*}%{!-n:%{_pearname}-%{version}} \
1114%define builddir %{_builddir}/%{srcdir} \
1115%setup -q -c -T %{-D:-D} -n %{srcdir} \
1116%{-z:tar zxf %{S:0}; %{-a:tar zxf %{S:%{-a*}}}} \
1117%{-z:_P=package2.xml; [ -f $_P ] || _P=package.xml; _N=%{srcdir}; mv $_P $_N; cd $_N} \
1118%pear_install \
e22fc3d1
ER
1119%{-z:cd ..} \
1120cat %{-z:$_N/}.install.log | %__pear_install_log \
1121\
d2a29d34 1122# undos sources \
07fa2259 1123find -type f -print0 | xargs -0 sed -i -e 's,\\r$,,' \
d2a29d34
ER
1124%{!?_noautocompressdoc:%global _noautocompressdoc %{nil}}%{expand:%%global _noautocompressdoc %{_noautocompressdoc} optional-packages.txt} \
1125%{!?_noautoprov:%global _noautoprov %{nil}}%{expand:%%global _noautoprov %{_noautoprov} 'pear(tests/.*)'} \
1126%{nil}
1127
0aced28c 1128# Copies exctracted PEAR package structure and PEAR registry to buildroot.
1ebc460a 1129# Author: Elan Ruusamäe <glen@pld-linux.org>
d2a29d34
ER
1130%pear_package_install() \
1131cp -a ./%{php_pear_dir}/{.registry,*} $RPM_BUILD_ROOT%{php_pear_dir} \
1132find $RPM_BUILD_ROOT%{php_pear_dir} '(' -name '*~' -o -name '*.orig' ')' | xargs -r rm -v \
1133# help the developer out a little: \
1134if [ -f _noautoreq ]; then \
1135 echo "AutoReqdep detected:" \
1136 echo "_noautoreq $(cat _noautoreq)" \
1137fi \
1138%{nil}
1139
54294c49
ER
1140
1141# Register OpenLDAP schema.
1ebc460a 1142# Author: Elan Ruusamäe <glen@pld-linux.org>
54294c49
ER
1143#
1144# Usage:
1145# %%openldap_schema_register [-d core,nis] %{schemadir}/horde.schema
1146#
1147# -d specify dependant schemas, separated by comma
1148#
1149%openldap_schema_register(d:) \
1150for schema in %*; do \
1151 if ! grep -q "$schema" /etc/openldap/slapd.conf; then \
1152 %{__sed} -i -e " \
1153 /^include.*local.schema/{ \
1154 iinclude\\t $schema\
1155 } \
1156 " /etc/openldap/slapd.conf \
1157 fi \
1158done \
1159# enable dependant schemas \
1160if [ "%{-d*}" ]; then \
1161 %{__sed} -i -e ' \
1162 /^#include.*\\(%(echo '%{-d*}' | %{__sed} -e 's/,/\\\\|/g')\\)\\.schema/{ \
1163 s/^#// \
1164 }' /etc/openldap/slapd.conf \
1165fi \
1166%{nil}
1167
1168# Unregister OpenLDAP schema.
1ebc460a 1169# Author: Elan Ruusamäe <glen@pld-linux.org>
54294c49
ER
1170#
1171# Usage:
1172# %%openldap_schema_unregister %{schemadir}/horde.schema
1173#
1174%openldap_schema_unregister() \
1175for schema in %*; do \
1176 if grep -q "$schema" /etc/openldap/slapd.conf; then \
1177 %{__sed} -i -e " \
1178 /^include.*$(echo "$schema" | %{__sed} -e 's,/,\\\\/,g')/d \
1179 # for symmetry it would be nice if we disable enabled schemas in post, \
1180 # but we really can not do that, it would break something else. \
1181 " /etc/openldap/slapd.conf \
1182 fi \
1183done \
1184%{nil}
1185
feb61fae 1186%env_update [ ! -x /sbin/env-update ] || /sbin/env-update -u || :
6ee06092 1187
a4623211 1188
1189# Build modules for kernels 2.6
1190# Author: Przemyslaw Iskra <sparky@pld-linux.org>
1191#
1192# Usage:
650cc681 1193# %build_kernel_modules -m <modules> -C <directory>
a4623211 1194#
1195# remember that proper Makefile is still required
1196# Options:
3c972982 1197# -m <modules> (required) -- comma-separated list of modules to save,
a4623211 1198# without .ko extension, may be placed in subdirectory
650cc681 1199# -C <directory> -- change to <directory> before doing anything
a4623211 1200# -p <arg>, -P <arg> -- arguments passeed to make scripts
bf97e3a6 1201# -c -- do not execute make clean
a4623211 1202# <additional arguments> -- all additional arguments will be passed to
1203# make modules
1204#
1205# Additional patching supported via here document. Try:
1206# %build_kernel_modules -m module <<'EOF'
1207# your patch script here
1208# EOF
1209# Don't use it unless patching depends on config options.
1210
1211# Developer note: don't touch it unless you know how to handle '\'.
1212# - \ in script expands to nothing
1213# - \\\ in script expands to \
8ad8b353 1214# - \\\ inside definition expands to nothing
a4623211 1215# - \\\\\\\ inside definition expands to \
1216# - in last line \ has to touch arguments so arguments passing
1217# in new lines (using \) will be supported
1218
bf97e3a6 1219%build_kernel_modules(p:P:m:C:c) \
a4623211 1220%{!?-m:%{error:%{0}: Required module name/list missing} exit 1} \
1221 \
1222%define Opts \\\\\\\
1223%if "%{_target_base_arch}" != "%{_arch}" \\\
1224 %if "%{_arch}" == "x86_64" && "%{_target_base_arch}" == "i386" \\\
4d45063a 1225 CC="%{kgcc}" ARCH=%{_target_base_arch} \\\
a4623211 1226 %else \\\
1227 ARCH=%{_target_base_arch} CROSS_COMPILE=%{_target_cpu}-pld-linux- \\\
1228 %endif \\\
1229%else \\\
4d45063a 1230 CC="%{kgcc}" \\\
a4623211 1231%endif \
4d45063a 1232%define MakeOpts HOSTCC="%{kgcc}" SYSSRC=%{_kernelsrcdir} SYSOUT=$PWD/o \\\\\\\
a4623211 1233 O=$PWD/o %{?with_verbose:V=1} %{Opts} \
1234 \
8b51c37f 1235%{?-C:cd %{-C*}} \
a4623211 1236compile() { \
1237 L="<"; [[ '%{*}' != *$L$L* ]] || PATCH_SH="set -x -e;$(cat)" \
1238 set -e -x \
d606f9ca 1239 local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
a4623211 1240 \
d606f9ca 1241for cfg in ${cfgs:-dist}; do \
a4623211 1242 [ -r "%{_kernelsrcdir}/config-$cfg" ] || exit 1 \
1243 \
8e042a98 1244 rm -rf o \
a4623211 1245 install -d o/include/linux \
1246 ln -sf %{_kernelsrcdir}/config-$cfg o/.config \
1247 ln -sf %{_kernelsrcdir}/Module.symvers-$cfg o/Module.symvers \
1248 ln -sf %{_kernelsrcdir}/include/linux/autoconf-$cfg.h o/include/linux/autoconf.h \
1249 \
1250 set +x \
1251 [ -z "$PATCH_SH" ] || echo "$PATCH_SH" | %__spec_build_shell \
1252 set -x \
1253 \
1254 %if %{with dist_kernel} \
1255 %{__make} -j1 -C %{_kernelsrcdir} prepare scripts \\\
1256 %{-p*} %{-P*} \\\
1257 %{MakeOpts} \
1258 %else \
1259 install -d o/include/config \
1260 touch o/include/config/MARKER \
1261 ln -sf %{_kernelsrcdir}/scripts o/scripts \
1262 %endif \
1263 \
bf97e3a6 1264 %{!?-c:%{__make} -C %{_kernelsrcdir} clean \\\
a4623211 1265 RCS_FIND_IGNORE="-name '*.ko' -o" \\\
220948bb 1266 ${1+"$@"} \\\
bf97e3a6 1267 M=$PWD %{MakeOpts}} \
220948bb 1268 \
a4623211 1269 %{__make} -C %{_kernelsrcdir} modules \\\
1270 ${1+"$@"} \\\
1271 M=$PWD %{MakeOpts} \
1272 \
1273 for MODULE in {%{-m*},}; do \
1274 [ -z "${MODULE}" ] || mv ${MODULE}{,-$cfg}.ko \
1275 done \
1276done \
650cc681 1277%{?-C:cd -} \
a4623211 1278} \
1279compile %{*}\
1280%{nil}
1281
1282
1283# Install kernel modules built by %build_kernel_modules
1284# Author: Przemyslaw Iskra <sparky@pld-linux.org>
1285#
1286# Usage:
1287# %install_kernel_modules -m <modules> -d <directory>
1288#
1289# Options:
3c972982 1290# -m <modules> (required) -- comma-separated list of modules to install,
a4623211 1291# without .ko extension, may be placed in subdirectory
1292# -d <directory> (required) -- in what subdirectory modules should be
1293# installed (eg. misc, kernel/drivers/net)
1294# -s <suffix> -- suffix to use when installing modules, useful when module
1295# with same name exists in kernel already
1296# -n <file> -- name of modprobe config file to use (without .conf extension)
c4bd6177 1297# for defining aliases, only useful with -s
a4623211 1298
1299%install_kernel_modules(m:d:s:n:) \
1300%{!?-m:%{error:%{0}: Required module name (-m) missing}exit 1} \
1301%{!?-d:%{error:%{0}: Required module directory missing}exit 1} \
1302%{?-n:%{!?-s:%{error:%{0}: Modprobe .conf file requires module suffix}exit 1}} \
1303 \
1304%define KernelD $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver} \
1305%define ModprobeD $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.d/%{_kernel_ver} \
c6bb8dfe 1306 \
d606f9ca 1307local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
a4623211 1308 \
1309for MODULE in {%{-m*},}; do \
1310 [ -n "${MODULE}" ] || continue \
d606f9ca
ER
1311 for cfg in ${cfgs:-dist}; do \
1312 [ "$cfg" = smp ] && suf=smp || suf= \
1313 MNAME=${MODULE##*/} \
1314 install -D ${MODULE}-$cfg.ko \\\
1315 %{KernelD}$suf/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko \
b37738c0 1316 %{?-s:install -d %{ModprobeD}$suf \
d606f9ca
ER
1317 echo "alias ${MNAME} ${MNAME}-%{-s*}" \\\
1318 >> %{ModprobeD}$suf/%{-n*}.conf} \
1319 done \
a4623211 1320done \
1321%{nil}
1322
16516cbd 1323# patchset macros
1ebc460a 1324# Author: Elan Ruusamäe <glen@pld-linux.org>
16516cbd
ER
1325#
1326# Usage:
1327# %patchset_source -f <seq(1) format> <start> [<end>]
1328# %patchset_patch <start> [<end>]
1329#
1330# If <end> is omited, it is assumed to be <start>.
1331#
1332# For example in preamble:
1333# %patchset_source -f ftp://ftp.vim.org/pub/editors/vim/patches/7.0/7.0.%03g 33 44
1334# and in %prep:
1335# %patchset_patch 33 44
1336
1337# generate SourceX urls from range START STOP
1338# Format can be SINGLE format char of %e, %f, %g, see seq(1)
1339# The sources start from 10000
cc2d394a 1340%patchset_source(f:b:) %(
8c40a202 1341 base=%{-b*}%{!-b*:10000};
3b7f1777
ER
1342 start=$(expr $base + %1);
1343 end=$(expr $base + %{?2}%{!?2:%{1}});
cc2d394a
ER
1344 # we need to call seq twice as it doesn't allow two formats
1345 seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
1346 seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
1347 paste %{tmpdir}/__ps{1,2};
1348 rm -f %{tmpdir}/__ps{1,2};
3b7f1777
ER
1349) \
1350%{nil}
16516cbd
ER
1351
1352# apply sources from %patchset_source
1353# -p specify -pX for %patch line
1354# -b base offset: defaults to 10000
1355%patchset_patch(f:p:b:) %(
8c40a202 1356 base=%{-b*}%{!-b*:10000};
3b7f1777
ER
1357 start=$(expr $base + %1);
1358 end=$(expr $base + %{?2}%{!?2:%{1}});
cc2d394a
ER
1359 echo ": patchset_patch %1%{?2: to %2}";
1360 seq -f 'patch%g %{-p*:-p%{-p*}}' $start $end | sed -e s,^,%%,;
3b7f1777
ER
1361) \
1362%{nil}
16516cbd 1363
c7cb683a 1364# browser plugins v2
1ebc460a 1365# Author: Elan Ruusamäe <glen@pld-linux.org>
c7cb683a
ER
1366#
1367# Usage:
1368# %browser_plugins_add_browser <name> -p <plugindir>
1369#
1370# <name> (required) -- name of the browser. usually %{name}.
1371# -p <plugindir> (required) -- in what directory browser searches for its plugins.
825d0960
ER
1372# -b -- default blacklists
1373# -a <arch> override arch
c7cb683a
ER
1374#
1375# Example:
1376# %browser_plugins_add_browser %{name} -p %{_firefoxdir}/plugins
1377
1378%_browserpluginsconfdir /etc/browser-plugins
292d3658 1379%_browserpluginsdir %{_libdir}/browser-plugins
c7cb683a
ER
1380%update_browser_plugins /usr/sbin/update-browser-plugins || :
1381
825d0960 1382%browser_plugins_add_browser(p:b:a:) \
2ac4652b 1383 browser=%1.%{!-a:%{_target_base_arch}}%{-a*} \
c7cb683a 1384 install -d $RPM_BUILD_ROOT%{_browserpluginsconfdir}/{blacklist,browsers}.d \
825d0960
ER
1385 ln -s %{-p*} $RPM_BUILD_ROOT%{_browserpluginsconfdir}/browsers.d/$browser \
1386 blacklist_file=$RPM_BUILD_ROOT%{_browserpluginsconfdir}/blacklist.d/$browser.blacklist \
c7cb683a
ER
1387 echo '# This file format is shell globs at base dir of plugindir' > $blacklist_file \
1388 %{-b:cat >> $blacklist_file %{-b*}} \
1389%{nil}
1390
c879189d
ER
1391# Helper for LUA.
1392# split string separated by space into quoted list
1393#
1ebc460a 1394# Author: Elan Ruusamäe <glen@pld-linux.org>
c879189d
ER
1395#
1396# %__lua_split /bin/sh /bin/pdksh -> "/bin/sh", "/bin/pdksh"
1397%__lua_split() %(echo "%*" | awk '{for (i=1;i<=NF;i++) printf("\\"%%s\\"%%s", $i, i == NF ? "" : ", ")}')
1398
1399# adjust /etc/shells by adding and removing shells from there
1ebc460a 1400# Author: Elan Ruusamäe <glen@pld-linux.org>
c879189d
ER
1401#
1402# Usage:
1403# %post -p %add_etc_shells -p /bin/sh /bin/pdksh
1404# %preun -p %remove_etc_shells -p /bin/sh /bin/pdksh
1405#
1406# -p (optional) -- specifies that result is embeded %post script (prepends <lua> as first line)
1407
1408%add_etc_shells(p) %{-p:<lua>}\
1409t = {}\
1410f = io.open("/etc/shells", "r")\
1411if f then\
1412 for l in f:lines() do t[l]=l; end\
1413 f:close()\
1414end\
1415for _, s in ipairs({%{expand:%%__lua_split %*}}) do\
1416 if not t[s] then\
b566b93e 1417 print("Adding "..s.." to /etc/shells")\
c879189d
ER
1418 f = io.open("/etc/shells", "a"); f:write(s.."\\n"); f:close()\
1419 end\
1420end\
1421%{nil}
1422
1423%remove_etc_shells(p) %{-p:<lua>}\
b566b93e 1424%{-p:if arg[2] == 0 then}\
39e5924d
ER
1425 t = {}\
1426 f = io.open("/etc/shells", "r")\
1427 if f then\
1428 for l in f:lines() do t[l]=l; end\
1429 f:close()\
1430 end\
1431 for _, l in pairs({%{expand:%%__lua_split %*}}) do\
b566b93e 1432 print("Removing "..l.." from /etc/shells")\
39e5924d
ER
1433 t[l] = nil\
1434 end\
1435 s=""\
1436 for _, l in pairs(t) do\
1437 s=s..l.."\\n"\
1438 end\
1439 io.open("/etc/shells", "w"):write(s)\
1440%{-p:end} \
c879189d
ER
1441%{nil}
1442
e22fc3d1 1443# vim:ts=4 sw=4 noet syn=spec
This page took 0.401464 seconds and 4 git commands to generate.